// WIN32 ONLY FILE	--	billdo 2001.0522

#ifndef __U_COMPAT__H
#define __U_COMPAT__H

#ifdef _WIN32

#undef _osmajor
#undef _osmanor
#define _osmajor _winmajor
#define _osminor _winminor

#undef _fstrlen
#undef _fstrcat
#undef _fstrncpy
#undef _fmemcpy
#undef _fstrcmp
#define _fstrlen strlen
#define _fstrcat strcat
#define _fstrncpy strncpy
#define _fmemcpy memcpy
#define _fstrcmp strcmp

#undef WINDOWS
#define WINDOWS

#if defined( _DLL ) || defined (_MT)
#undef _WINDLL
#define _WINDLL
#endif

#endif// _WIN32

/* Recovering missing WinSock error macros */
#ifndef EWOULDBLOCK

#define EWOULDBLOCK             WSAEWOULDBLOCK
#define EINPROGRESS             WSAEINPROGRESS
#define EALREADY                WSAEALREADY
#define ENOTSOCK                WSAENOTSOCK
#define EDESTADDRREQ            WSAEDESTADDRREQ
#define EMSGSIZE                WSAEMSGSIZE
#define EPROTOTYPE              WSAEPROTOTYPE
#define ENOPROTOOPT             WSAENOPROTOOPT
#define EPROTONOSUPPORT         WSAEPROTONOSUPPORT
#define ESOCKTNOSUPPORT         WSAESOCKTNOSUPPORT
#define EOPNOTSUPP              WSAEOPNOTSUPP
#define EPFNOSUPPORT            WSAEPFNOSUPPORT
#define EAFNOSUPPORT            WSAEAFNOSUPPORT
#define EADDRINUSE              WSAEADDRINUSE
#define EADDRNOTAVAIL           WSAEADDRNOTAVAIL
#define ENETDOWN                WSAENETDOWN
#define ENETUNREACH             WSAENETUNREACH
#define ENETRESET               WSAENETRESET
#define ECONNABORTED            WSAECONNABORTED
#define ECONNRESET              WSAECONNRESET
#define ENOBUFS                 WSAENOBUFS
#define EISCONN                 WSAEISCONN
#define ENOTCONN                WSAENOTCONN
#define ESHUTDOWN               WSAESHUTDOWN
#define ETOOMANYREFS            WSAETOOMANYREFS
#define ETIMEDOUT               WSAETIMEDOUT
#define ECONNREFUSED            WSAECONNREFUSED
#define ELOOP                   WSAELOOP
#define EHOSTDOWN               WSAEHOSTDOWN
#define EHOSTUNREACH            WSAEHOSTUNREACH
#define EPROCLIM                WSAEPROCLIM
#define EUSERS                  WSAEUSERS
#define EDQUOT                  WSAEDQUOT
#define ESTALE                  WSAESTALE
#define EREMOTE                 WSAEREMOTE

/* #define ENAMETOOLONG         WSAENAMETOOLONG 
   #define ENOTEMPTY               WSAENOTEMPTY */ /* il -- conflict with errno.h */

#endif	// EWOULDBLOCK

#ifndef bcopy
#define bcopy(a,b,c) memcpy( (b), (a), (c) )
#endif
#ifndef bzero
#define bzero(a,b) memset( (a), 0, (b) )
#endif

#endif // __U_COMPAT__H
